#!/usr/local/bin/perl5 -w

###########################################################################
#
# touc.pl -- converts to unicode
#
# Copyright (C) 1999 DigiLib Systems Limited, NZ.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
###########################################################################

BEGIN {
    die "GSDLHOME not set\n" unless defined $ENV{'GSDLHOME'};
    unshift (@INC, "$ENV{'GSDLHOME'}/perllib");
}

use unicode;
use multiread;
use parsargv;


$encoding = "utf8";
if (!parsargv::parse(\@ARGV, 
		     'unicode', \$unicode,
		     'extended', \$extended,
		     'gb', \$gb)) {
    print STDERR "\n  usage: $0 [options]\n\n";
    print STDERR "  options:\n";
    print STDERR "   -utf8     input is in utf-8 or unicode (default)\n";
    print STDERR "   -extended input is in extended ascii\n";
    print STDERR "   -gb       input is in GB or GBK\n\n";
    die "\n";
}

$encoding = "utf8" if $unicode;
$encoding = "extended" if $extended;
$encoding = "gb" if $gb;


if ($ENV{'GSDLOS'} =~ /windows/i) {
    binmode (STDOUT); # silly windows
}

# output in little endian
print "\xff\xfe";

$reader = new multiread ();
$reader->set_handle ('main::STDIN');
$reader->set_encoding ($encoding);
$line = "";
$ucline = [];
while (defined ($line = $reader->read_line())) {
    $ucline = &unicode::utf82unicode ($line);
    foreach $c (@$ucline) {
	$c1 = chr (int ($c / 256));
	$c2 = chr (int ($c % 256));
	print "$c2$c1";
    }
}
